/* See license.txt for terms of usage */

try {
	(function() {
		if(this.Constants){
			return;
		}

		const Cc = Components.classes;
		const Ci = Components.interfaces;
		const Cr = Components.results;
		
		var app = Cc["@mozilla.org/fuel/application;1"].getService(Ci.fuelIApplication);
		
		var _this = this;
		
		var FBTrace = this.FBTrace;
		
		var constants = {};

		constants.HTML_ELEMENTS = [
				"HTMLAnchorElement",
				"HTMLAppletElement",
				"HTMLAreaElement",
				"HTMLBaseElement",
				"HTMLBaseFontElement",
				"HTMLBodyElement",
				"HTMLBRElement",
				"HTMLButtonElement",
				"HTMLDirectoryElement",
				"HTMLDivElement",
				"HTMLDListElement",
				"HTMLFieldSetElement",
				"HTMLFontElement",
				"HTMLFormElement",
				"HTMLFrameElement",
				"HTMLFrameSetElement",
				"HTMLHeadElement",
				"HTMLHeadingElement",
				"HTMLHRElement",
				"HTMLHtmlElement",
				"HTMLIFrameElement",
				"HTMLImageElement",
				"HTMLInputElement",
				"HTMLIsIndexElement",
				"HTMLLabelElement",
				"HTMLLegendElement",
				"HTMLLIElement",
				"HTMLLinkElement",
				"HTMLMapElement",
				"HTMLMenuElement",
				"HTMLMetaElement",
				"HTMLModElement",
				"HTMLObjectElement",
				"HTMLOListElement",
				"HTMLOptGroupElement",
				"HTMLOptionElement",
				"HTMLParagraphElement",
				"HTMLParamElement",
				"HTMLPreElement",
				"HTMLQuoteElement",
				"HTMLScriptElement",
				"HTMLSelectElement",
				"HTMLStyleElement",
				"HTMLTableCaptionElement",
				"HTMLTableCellElement",
				"HTMLTableColElement",
				"HTMLTableElement",
				"HTMLTableRowElement",
				"HTMLTableSectionElement",
				"HTMLTextAreaElement",
				"HTMLTitleElement",
				"HTMLUListElement",
				"HTMLUnknownElement" ];
		
		constants.AV_MIME_TYPES = [ "video/mp4", "video/mpeg", "video/mpeg4", "audio/mp3", "audio/mpeg", "audio/mp4" ];
		
		constants.USERAGENT_SUFFIX = "firetv-firefox-plugin";
		
		constants.EXTENSION_ID = "dlfr-firetv-plugin@atosorigin.com"; 
		
		constants.VERSION = "";
		
		app.getExtensions(function(extensions) {
			constants.VERSION = extensions.get(constants.EXTENSION_ID).version;
		});
		
		this.Constants = constants;

	}).apply(getFireTVPluginInstance());

} catch (exc) {
	alert("[ftv-constants.js] " + exc);
}