/* See license.txt for terms of usage */

define([ "firebug/firebug", "firebug/lib/trace", "firebug/lib/url", "firebug/lib/dom" ], function(Firebug, FBTrace,
		Url, Dom) {
	var CAT = "[ftv-firebug] ";
	
	var FBTrace = {};
	
	const Cc = Components.classes;
	const Ci = Components.interfaces;
	const Cr = Components.results;
	
	var windowManager = Cc['@mozilla.org/appshell/window-mediator;1'].getService(Ci.nsIWindowMediator);
	var enumerator = windowManager.getEnumerator(null);
	while (enumerator.hasMoreElements()) {
		var win = enumerator.getNext();
		if (win.FireTVPlugin) {
			FBTrace = win.FireTVPlugin.FBTrace;
		}
	}
	
	var theApp = {
		initialize : function() {

			if (FBTrace.DBG_FIRETV_FIREBUG) {
				FBTrace.sysout(CAT + "[initialize]");
			}
			if (FBTrace.DBG_FIRETV_FIREBUG) {
				FBTrace.sysout(CAT + "[initialize] Override system url detection");
			}
			var origIsSystemURL = Url.isSystemURL;
			Url.isSystemURL = function() {
				var res = origIsSystemURL.apply(null, arguments);
				var url = (arguments.length > 0) ? arguments[0] : false;
				if (url && url.length > 20) {
					res = res || (url.substr(0, 28) == "data:text/css;charset=firetv");
				}
				return res;
			};

			var origGetLTRBWH = Dom.getLTRBWH;
			Dom.getLTRBWH = function(elt) {
				var res = origGetLTRBWH.apply(null, arguments);
				if (elt && elt.ownerDocument.defaultView.frameElement === null
						&& elt.ownerDocument.documentElement.tagName != "svg" && elt.ownerDocument.documentElement.getAttribute("firetv-class") == "firetv") {
					if (!res.firetvAdjusted) {
						var win = elt.ownerDocument.defaultView;
						if (elt == elt.ownerDocument.body || elt == elt.ownerDocument.documentElement){
							var scaleX = 1;
							var scaleY = 1;
//							if (elt == elt.ownerDocument.body){
//								var transform = win.getComputedStyle( elt.ownerDocument.body, null)["MozTransform"].replace(/^matrix\(/,
//								"").replace(/\)$/, "").split(",");
//								scaleX = parseFloat(transform[0]);
//								scaleY = parseFloat(transform[3]);
//							}
							res = {
								top: 0,
								left : 0,
								bottom: 0,
								right : 0,
								width: ( elt.ownerDocument.body.offsetWidth / scaleX),
								height: ( elt.ownerDocument.body.offsetHeight / scaleY)
							};
							if (FBTrace.DBG_FIRETV_FIREBUG) {
								FBTrace.sysout(CAT + "[#" + elt.getAttribute("id") + "] " + res.firetvAdjusted + " top=" + res.top + ", left=" + res.left + ", width=" + res.width + ", height=" + res.height);
							}
							return res;
	
						} else {
							var deltaTop = win.getComputedStyle(elt.ownerDocument.documentElement, null).paddingTop;
							deltaTop = deltaTop.replace(/px$/, "") >> 0;
							var deltaLeft = win.getComputedStyle(elt.ownerDocument.body, null).left;
							if (deltaLeft !== "auto") {
								deltaLeft = deltaLeft.replace(/px$/, "") >> 0;
							} else {
								deltaLeft = 0;
							}
							if (FBTrace.DBG_FIRETV_FIREBUG) {
								FBTrace.sysout(CAT + "[#" + elt.getAttribute("id") + "] " + res.firetvAdjusted + " top=" + res.top + ", left=" + res.left + ", width=" + res.width + ", height=" + res.height + " (deltaTop=" + deltaTop + ", deltaLeft=" + deltaLeft);
							}
							res.top -= deltaTop;
							res.left -= deltaLeft;
							res.firetvAdjusted = true;
						}
					}
				}

				return res;
			};


			var origShouldCacheRequest = Firebug.TabCacheModel.shouldCacheRequest;
			Firebug.TabCacheModel.shouldCacheRequest = function(request) {
				var res = origShouldCacheRequest.apply(Firebug.TabCacheModel, [ request ]);
				var shouldCache = false;
				try {
					shouldCache = (request.URI.scheme == "firetv") || 
						(request.URI.scheme == "tv") || 
						((request.URI.scheme == "dvb")&& !/\.png$/.test(request.URI.spec)
								&& !/\.jpg$/.test(request.URI.spec)
								&& !/\.gif$/.test(request.URI.spec));
				} catch (e) {
				}
				return res || shouldCache;
			};

			if (FBTrace.DBG_FIRETV_FIREBUG) {
				FBTrace.sysout(CAT + "[done]");
			}
		}
	}
	return theApp;
});
