/* See license.txt for terms of usage */

// -- available functions :
//       -> this.nodeToString(node)
//       -> this.getCustomCSSValue(node, property)
(function() {
	if (!FireTVPlugin.customCSSHooks) {
		FireTVPlugin.customCSSHooks = {};
	}

	FireTVPlugin.customCSSHooks["transparency"] = {
		"property" : "transparency",
		"listenTo" : [ "background-color", "background" ],
		"callback" : function(node, property, triggeredBy) {
			var val = this.getCustomCSSValue(node, property);
			if (val !== null) {
				// console.info("[" + property + ".callback] triggered by " +
				// triggeredBy + " [val=" + val + "] on "
				// + this.nodeToString(node));
				node.setAttribute("firetv-" + property, val);
			} else {
				node.removeAttribute("firetv-" + property);
			}
		},
		"getter" : function() {
			var node = FireTVPlugin.lastStyleAccessOnNode;
			var transparency = node.getAttribute("firetv-transparency");
			if (transparency) {
				return transparency;
			} else {
				return 255;
			}
		},
		"setter" : function(t) {
			var node = FireTVPlugin.lastStyleAccessOnNode;
			node.setAttribute("firetv-transparency", t);
			FireTVPlugin.customCSSHooks["transparency"].callback.apply(this, [ node, "transparency", "transparency" ]);
		}
	}
})();
