/* See license.txt for terms of usage */

(function() {
	var debug = function() {
		var i;
		var args = ["[FlashPlayer."+debug.caller.name+"("];
		for (i = 0; i < debug.caller.arguments.length; i++) {
			args[0] +=  debug.caller.arguments[i];
			args.push(debug.caller.arguments[i]);
			if (i < debug.caller.arguments.length - 1) {
				args[0] += ", ";
			}
		}
		args[0] += ")]";
		for (i = 0; i < arguments.length; i++) {
			args.push(arguments[i]);
		}
//		console.log.apply(console, args);
	};

	var PlayState = {
		STOPPED : 0,
		PLAYING : 1,
		PAUSED : 2,
		CONNECTING : 3,
		BUFFERING : 4,
		FINISHED : 5,
		ERROR : 6
	};
	
	var ErrorState = {
		AV_FORMAT_NOT_SUPPORTED: 0,
		CANNOT_CONNECT_TO_SERVER: 1,
		UNIDENTIFIED_ERROR: 2
	};

	var FLASH_CLASSNAME = "firetv-flash-player";

	function FlashPlayer() {

	}

	var flashMediaPlayerPrototype = {
		"setData" : {
			value : function setData(target, val) {
				var flashApi = this._getFlashApi(target);
				if(flashApi){
					flashApi.call(this._getFlashObject(target), "set", "data", val);
				} else {
					if (val != target._firetvData){
						target._firetvQueue = [];
					}
					target._firetvData = val;
				}
			},
			writable : false,
			enumerable : true
		},
		"_onPlayStateChangeHandlers" : {
			value : {},
			writable : true,
			enumerable : false
		},
		"_targetDetails" : {
			value : {},
			writable : true,
			enumerable : false
		},
		"_flashLoadedCallback" : {
			value : function _ready(flashObjectId) {
				debug("[_flashLoadedCallback] objId: " + flashObjectId);
				var obj = document.getElementById(flashObjectId);
				debug("[_flashLoadedCallback] obj: " + obj );
				if (!obj){
					return;
				}
				var targetDetail = this._targetDetails[flashObjectId];
				targetDetail.loaded = true;
				
				
				var target = obj.parentNode;
				debug("[_flashLoadedCallback] target: " + target + ((target)?" #" + target.id:"") );
				var flashApi = null;
				try {
					flashApi = this._getFlashApi(target);
				} catch(e){
				}
				debug("[_flashLoadedCallback] flashApi: " + flashApi );
				if (!flashApi){
					return;
				}
				if (target.hasOwnProperty("_firetvPlayState")) {
					debug("[_flashLoadedCallback] updating playstate: " +  target._firetvPlayState);
					flashApi.call(this._getFlashObject(target), "set", "playState", target._firetvPlayState);
				}
				if (target.hasOwnProperty("_firetvOnPlayStateChange")) {
					debug("[_flashLoadedCallback] updating onPlayStateChange: " +  target._firetvOnPlayStateChange);
					flashApi.call(this._getFlashObject(target), "set", "onPlayStateChange", target._firetvOnPlayStateChange);
				}
				if (target.hasOwnProperty("_firetvData")) {
					debug("[_flashLoadedCallback] updating data: " +  target._firetvData);
					flashApi.call(this._getFlashObject(target), "set", "data", target._firetvData);
				}
				if (target.hasOwnProperty("_firetvWantedSpeed")) {
					debug("[_flashLoadedCallback] calling play() at speed: " +  target._firetvWantedSpeed);
					flashApi.call(this._getFlashObject(target), "call", "play", target._firetvWantedSpeed);
				}
				if (target.hasOwnProperty("_firetvQueue")) {
					var i;
					for (i=0; i<target._firetvQueue.length; i++){
						debug("[_flashLoadedCallback] updating queue item: " +  target._firetvQueue[i]);
						flashApi.call(this._getFlashObject(target), "call", "queue", target._firetvQueue[i]);
					}
				}
				
				delete target._firetvQueue;
				delete target._firetvData;
				delete target._firetvPlayState;
				delete target._firetvOnPlayStateChange;
				delete target._firetvWantedSpeed;
			},
			writable : false,
			enumerable : false
		},
		"_getFlashObject" : {
			value : function _getFlashObject(target) {
				var flash = target.querySelector("." + FLASH_CLASSNAME);
				if (flash) {
					return flash;
				} else {
					target.innerHTML = "";
					flash = document.createElement("object");
					flash.setAttribute("type", "application/x-shockwave-flash");
					flash.setAttribute("style", "width:100%; height:100%; position:relative; left:0; top:0");
					flash.setAttribute("tabindex", "-1");
					flash.setAttribute("class", FLASH_CLASSNAME);
					
					var id = FLASH_CLASSNAME + "-" + new String(Math.random()).substring(2);
					flash.setAttribute("id", id);
					flash.setAttribute("name", id);
					
					var param;
					param = document.createElement("param");
					param.setAttribute("name", "allowScriptAccess");
					param.setAttribute("value", "always");
					flash.appendChild(param);
					param = document.createElement("param");
					param.setAttribute("name", "wmode");
					param.setAttribute("value", "opaque");
					flash.appendChild(param);
					
					var mode = "video";
					if (target.type.match(/audio\//)){
						mode = "audio";
					}
					var flashvars = "mode=" + mode;
					flashvars += "&deviceWidth=" + FireTVPlugin.profileDefinition.resolution.width;
					flashvars += "&deviceHeight=" + FireTVPlugin.profileDefinition.resolution.height;
					param = document.createElement("param");
					param.setAttribute("name", "flashvars");
					param.setAttribute("value", flashvars);
					flash.appendChild(param);
					
					var targetDetail = {
						flashId : id,
						loaded: false,
						error: false,
						queue: []
					};
					this._targetDetails[id] = targetDetail;
					
					flash.setAttribute("data", "http://tum-iptv.aw.atosorigin.com/firehbbtv/FireTVPlayer.swf");
					
					flash.firebugIgnore = true;
					target.appendChild(flash);
					return flash;
				}
			},
			writable : false
		},

		"_getFlashApi" : {
			value : function _getFlashApi(target) {
				var flash = this._getFlashObject(target);
				var targetDetail = this._targetDetails[flash.id];
				if (targetDetail && targetDetail.error){
					return null;
				}
				if (targetDetail && !targetDetail.firstAccessDate){
					targetDetail.firstAccessDate = new Date().getTime(); 
				}
				var ready = false;
				try {
					ready = flash.bridge.apply(this._getFlashObject(target),["call", "ready"]);
				} catch(e){
					a = e;
					// -- not ready
					var targetDetail = this._targetDetails[flash.id];
					var now = new Date().getTime();
					var delta = now - targetDetail.firstAccessDate;
					if (delta > 5000){
						// it's been five seconds since the creation and still nothing loaded, set as error
						targetDetail.error = true;
						if (target._firetvPlayState !== PlayState.ERROR) {
							target._firetvPlayState = PlayState.ERROR;
							target._firetvError = ErrorState.UNIDENTIFIED_ERROR;
							var callback = this.getOnPlayStateChange(target);
							if (callback){
								callback();
							}
						}
					}
				}
				if (ready) {// && flash.bridge("call", "ready") == true) {
					return flash.bridge;
				} else {
					return null;
				}
			},
			writable : false,
			enumerable : false
		},

		// -- real media player API
		"getPlayPosition" : {
			value : function getPlayPosition(target) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					return flashApi.call(this._getFlashObject(target), "get", "playPosition");
				} else {
					return 0;
				}
			},
			writable : false,
			enumerable : true
		},
		"getPlayTime" : {
			value : function getPlayTime(target) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					return flashApi.call(this._getFlashObject(target), "get", "playTime");
				} else {
					return undefined;
				}
			},
			writable : false,
			enumerable : true
		},
		"getPlayState" : {
			value : function getPlayState(target) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					return flashApi.call(this._getFlashObject(target), "get", "playState");
				} else {
					if (target.hasOwnProperty("_firetvPlayState")) {
						return target._firetvPlayState;
					}
					return PlayState.STOPPED;
				}
			},
			writable : false,
			enumerable : true
		},
		"getError" : {
			value : function getError(target) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					return flashApi.call(this._getFlashObject(target), "get", "error");
				} else {
					if (target.hasOwnProperty("_firetvError")) {
						return target._firetvError;
					}
					return undefined;
				}
			},
			writable : false,
			enumerable : true
		},
		"getSpeed" : {
			value : function getSpeed(target) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					return flashApi.call(this._getFlashObject(target), "get", "speed");
				} else {
					return 0;
				}
			},
			writable : false,
			enumerable : true
		},
		"getOnPlayStateChange" : {
			value : function getOnPlayStateChange(target) {
				return this._onPlayStateChangeHandlers[target.getAttribute("firetv-proxy-id")] || null;
			},
			writable : false,
			enumerable : true
		},
		"setOnPlayStateChange" : {
			value : function setOnPlayStateChange(target, val) {
				this._onPlayStateChangeHandlers[target.getAttribute("firetv-proxy-id")] = val;
			},
			writable : false,
			enumerable : true
		},
		"_callOnPlayStateChange" : {
			value : function _callOnPlayStateChange(flashObjectId) {
				var obj = document.getElementById(flashObjectId);
				if (!obj){
					return;
				}
				var target = obj.parentNode;
				var callback = this.getOnPlayStateChange(target);
				if (callback){
					callback();
				}
			},
			writable : false,
			enumerable : true
		},
		"play" : {
			value : function play(target, speed) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					var playState = flashApi.call(this._getFlashObject(target), "get", "playState");
					if(playState != PlayState.PAUSED && playState != PlayState.PLAYING) {
						flashApi.call(this._getFlashObject(target), "set", "playState", PlayState.CONNECTING);
					}
					flashApi.call(this._getFlashObject(target), "call", "play", speed);
				} else {
					if(target._firetvPlayState != PlayState.PAUSED && target._firetvPlayState != PlayState.PLAYING) {
						target._firetvPlayState = PlayState.CONNECTING;
					}
					target._firetvWantedSpeed = speed;
				}

			},
			writable : false,
			enumerable : true
		},
		"stop" : {
			value : function stop(target) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					flashApi.call(this._getFlashObject(target), "call", "stop");
				} else {
					delete target._firetvWantedSpeed;
					target._firetvQueue = [];
					target._firetvPlayState = PlayState.STOPPED;
				}
			},
			writable : false,
			enumerable : true
		},
		"seek" : {
			value : function seek(target, positionInMilliseconds) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					return flashApi.call(this._getFlashObject(target), "call", "seek", positionInMilliseconds);
				} else {
					return false;
				}
			},
			writable : false,
			enumerable : true
		},
		"queue" : {
			value : function queue(target, uri) {
				var flashApi = this._getFlashApi(target);
				if (flashApi) {
					return flashApi.call(this._getFlashObject(target), "call", "queue", uri);
				} else {
					// manage queue
					if (uri === null) {
						target._firetvQueue = [];
						return true;
					} else {
						if (!target._firetvQueue){
							target._firetvQueue = [];
						}
						if (target._firetvQueue.indexOf(uri) > -1) {
							return false;
						} else {
							if (target._firetvData && typeof target._firetvWantedSpeed === "undefined"){
								delete target._firetvData;
							}
							target._firetvQueue.push(uri);
							if (target._firetvQueue.length === 1
									&& (target._firetvPlayState == PlayState.ERROR
											|| target._firetvPlayState == PlayState.STOPPED || target._firetvPlayState == PlayState.FINISHED)) {
								this.setData(target, target._firetvQueue.splice(0, 1)[0]);
								this.play(target, 1);
							}
							return true;
						}
					}
				}
			},
			writable : false,
			enumerable : true
		},

		"getFullScreen" : {
			value : function getFullScreen(target) {
				if (!target.hasOwnProperty("firetvFullscreen")) {
					target.firetvFullscreen = false;
				}
				return target.firetvFullscreen;
			},
			writable : false,
			enumerable : true
		},
		"getOnFullScreenChange" : {
			value : function getOnFullScreenChange(target) {
				if (!target.hasOwnProperty("firetvOnFullScreenChange")) {
					target.firetvOnFullScreenChange = null;
				}
				return target.firetvOnFullScreenChange;
			},
			writable : false,
			enumerable : true
		},
		"setOnFullScreenChange" : {
			value : function setOnFullScreenChange(target, val) {
				target.firetvOnFullScreenChange = val;
			},
			writable : false,
			enumerable : true
		},
		"setFullScreen" : {
			value : function setFullScreen(target, fullScreen) {
				if (!target.hasOwnProperty("firetvFullscreen")) {
					target.firetvFullscreen = false;
				}
				target.setAttribute("firetv-fullscreen", fullScreen);
				if (fullScreen != target.firetvFullscreen) {
					var flash = this._getFlashObject(target);
					if (fullScreen === true) {
						var bodyBounds = document.body.getBoundingClientRect();
						var flashBounds = flash.getBoundingClientRect();
						var bounds = {
							left: bodyBounds.left - flashBounds.left,
							top:  bodyBounds.top - flashBounds.top
						};
						target.style.overflow = "visible";
						flash.style.width = FireTVPlugin.profileDefinition.resolution.width + "px";
						flash.style.height = FireTVPlugin.profileDefinition.resolution.height + "px";
						flash.style.top =  (Math.round(bounds.top)) + "px";
						flash.style.left = (Math.round(bounds.left)) + "px";
					} else {
						target.style.overflow = "visible";
						flash.style.width = "100%";
						flash.style.height = "100%";
						flash.style.top = "0";
						flash.style.left = "0";
					}
					target.firetvFullscreen = fullScreen;
					if (target.onFullScreenChange) {
						target.onFullScreenChange.apply(this, []);
					}
				}
			},
			writable : false,
			enumerable : true
		}
	};

	Object.defineProperties(FlashPlayer.prototype, flashMediaPlayerPrototype);

	FireTVPlugin.FlashPlayer = new FlashPlayer();

})();